/*
 * wnix, a Unix-like operating system for WebAssembly applications.
 * Copyright (C) 2025  Xavier Del Campo Romero
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

#include <bin.h>
#include <bin/proc.h>
#include <bin/types.h>
#include <stddef.h>

int bin_proc_move(struct bin_proc *const p, struct bin *const from,
    struct bin *const to)
{
    if (from)
    {
        if (from->proc_head == p)
            from->proc_head = p->next;

        if (from->proc_tail == p)
            from->proc_tail = p->prev;
    }

    if (p->next)
        p->next->prev = p->prev;

    if (p->prev)
        p->prev->next = p->next;

    if (to)
    {
        if (!to->proc_head)
        {
            to->proc_head = p;
            p->prev = p->next = NULL;
        }
        else
        {
            struct bin_proc *const t = to->proc_tail;

            t->next = p;
            p->prev = t;
            p->next = NULL;
        }

        to->proc_tail = p;
    }

    return 0;
}
